#!/home/r/roBin/env-cool java -cp /home/r/roBin/libs/*:/home/r/roBin/src:/home/r/roBin/rlm-lib/* -Xms1g -Xmx1g clojure.main

(ns rlm.clj
  (:use [clojure.contrib
	 [duck-streams :only [file-str] ]
	 command-line str-utils shell-out
	 [seq :only [indexed]]]
      [rlm shell-write]))

(defn clj [& args]
  (with-command-line args 
    "Simple Clojure shebang (#!) lines"
    [[classpath c "java classpath in which this script will run.  rlm is always on the classpath." 
      "/home/r/roBin/libs/*:/home/r/roBin/rlm-lib/*:/home/r/roBin/src"]
     [memory m "how much memory should this stupid jvm be provided? (megabytes)" 1000]
     [garbage g "level of congestion after which the jvm starts garbage collecting (megabytes)"
      "30% of whatever memory is"]
     [libraries l "link in libraries under -Djava.library.path" ""]
     [configure conf "use a file with configureations to defeat shebang line limit don't double define things:) " "/dev/null"]
     target-files]

    (if (not (= configure "/dev/null"))
      (apply clj (into (re-split #" " (chomp (slurp configure))) target-files)) 

    (let [
	  adjusted-garbage
	  (if (string? garbage)
	    (int (* 0.3  (Integer. memory)))
	    garbage)]
      
      ;assemble arguments to be passed to java
      (let [java-args
	    (into
	     ["-cp" classpath
	      (str "-Xmn" adjusted-garbage "M")
	      (str "-Xmx" memory "M")
	      (str "-Xms" memory "M")
	      (str "-Djava.library.path=\"" libraries "\"")
	      "clojure.main"]
	     target-files)]
	(let [command  (str "java " (str-join " " java-args))]
	  (println command)
	  (sw command)
	  ))))))





(if *command-line-args*
  (let [options #{"-c" "-g" "-m" "-l" "-conf"}
	fuck (split-with (fn [[index element]] (or (odd? index) (options element))) 
		       (indexed *command-line-args*))
	fuck2 (conj (apply vector (map last (first fuck))) (str-join " " (map last (last fuck))))
	]
    (apply clj fuck2)))


