(ns rlm.println)


(def println-repl (bound-fn [& args] (apply println args)))



(defn println-terminal [& more]
     (.println System/out (apply str more)))


(defmacro print-to-repl [& forms]
  `(binding [clojure.core/*out*
	     (java.io.PrintWriter. (clojure.java.io/writer System/out))]
     ~@forms))

