(ns rlm.sanitize-file
  (:import java.io.File)
  (:use clojure.contrib.str-utils))


(defn sanitize-file-name
  "given a file name, convert it into a valid file name.
   currently only works for linux"
  [#^String name]
  ;; as far as I know, all that must be done is removal of the
  ;; path separator.

  (re-gsub
   (re-pattern (str File/separatorChar))
   " " ;; replace "/" with " "
   name))



