(ns rlm.web-stuff)


;;(from http://www.mail-archive.com/clojure@googlegroups.com/msg31123.html
(defn convolve [ns ms]
  (let [ns (vec ns), ms (vec ms),
	count-ns (count ns), count-ms (count ms)]
    (loop [n 0,
	   y (transient (vec (repeat (dec (+ count-ns count-ms)) 0)))]
      (if (= n count-ns) (persistent! y)
	  (recur (inc n)
		 (loop [m 0, y y]
		   (if (= m count-ms) y
		       (let [n+m (+ n m)]
			 (recur (inc m) (assoc! y n+m
						(+ (y n+m) (* (ns n) (ms
								      m)))))))))))));;)


